def racine_balayage_opt(nombre, nb_decimales):
    """détermine  par balayage un encadrement de la racine carrée d'un nombre d’amplitude 10**(-nb_decimales), en optimisant la borne inférieure de l'encadrement à chaque tour de boucle"""
    debut = 0 # on crée une variable début qui recevra tour à tour les bornes inférieures de chaque encadrement
    compteur = 0
    for i in range(0,nb_decimales + 1) :
        pas = 10**(-i)
        x = debut # on commence le balayage à début et on reprend l'algorithme de balayage initial
        while x**2 < nombre :
            x = x  + pas
            compteur = compteur + 1
        debut = x - pas # pour le prochain balayage, on repartira avec la borne inférieure de l'encadrement obtenu
    return round(debut, nb_decimales), round(debut + pas, nb_decimales), compteur # on renvoie le dernier encadrement obtenu