def racine_dicho(nombre,nb_decimales):
    """détermine par dichotomie un encadrement de la racine carrée d'un nombre d'amplitude 10**(-nb_decimales) en partant d'un encadrement à l'unité a et b"""
    x = 0 # on reprend l'algorithme de balayage pour trouver un encadrement à l'unité de la racine carrée
    while x**2 < nombre :
        x = x + 1
    debut = x - 1
    fin = x
    compteur = 0
    while abs(fin-debut) > 10**(-nb_decimales):
        milieu = (debut + fin) / 2
        if milieu**2 <= nombre :
            debut = milieu
        else :
            fin = milieu
        compteur = compteur + 1
    return round(debut, nb_decimales), round(fin, nb_decimales), compteur