import math;
import markers;
import geometry;
import patterns;
import labelpath;
import graph ;
//pour une sortie pdf :
settings.outformat="pdf";
//texpreamble("\usepackage[T1]{fontenc}\usepackage[french]{babel}\DecimalMathComma");//pour charger des packages avec options
usepackage("amsmath");
real unite=1;
unitsize(2.1cm);
path rectangle(pair A, pair B, pair C, pair D){
path p;
p=A--B--C--D--cycle;
return p;
}
pair A[];
A[1]=(0,0);A[2]=(2,0);A[3]=(2,1); A[4]=(0,1);
path rect1=A[1]--A[2]--A[3]--A[4]--cycle;
draw(rect1);
void coteangledroit(pair A, pair B, pair C, pair D,pen sty=currentpen)
{markrightangle(D,A,B);
markrightangle(A,B,C);
markrightangle(B,C,D);
markrightangle(C,D,A);}
coteangledroit(A[1],A[2],A[3],A[4]);
distance("$2$", A[1],A[2], 8mm, joinpen=dashed, darkgray);
distance("$1$", A[4],A[1], rotated=false,8mm, joinpen=dashed,darkgray);

real decalage[];
decalage[1]=3.5;
A[5]=shift((decalage[1],0))*A[1];
A[6]=shift((1.5,0))*A[5];
A[7]=shift((0,4/3))*A[6];
A[8]=shift((-1.5,0))*A[7];
path rect2=A[5]--A[6]--A[7]--A[8]--cycle;
draw(rect2);
distance("$\dfrac{\phantom{1}\ldots\phantom{1}+\phantom{1}\ldots\phantom{1}}{2}=\dfrac{\ldots}{\ldots}$", A[5],A[6], 8mm, joinpen=dashed, darkgray);
distance("$2\div \dfrac{\phantom{1}\ldots\phantom{1}}{\phantom{1}\ldots\phantom{1}}=\dfrac{\phantom{1}\ldots\phantom{1}}{\phantom{1}\ldots\phantom{1}}$", A[8],A[5], rotated=false,12mm, joinpen=dashed,darkgray);
coteangledroit(A[5],A[6],A[7],A[8]);
decalage[2]=3;
A[9]=shift((decalage[2],0))*A[5];
A[10]=shift((17/12,0))*A[9];
A[11]=shift((0,24/17))*A[10];
A[12]=shift(A[9]-A[10])*A[11];
path rect3=A[9]--A[10]--A[11]--A[12]--cycle ;
draw(rect3);
coteangledroit(A[9],A[10],A[11],A[12]);
distance("$\dfrac{\dfrac{\phantom{1}\phantom{1}\ldots\phantom{1}\phantom{1}}{\phantom{1}\ldots\phantom{1}}+\dfrac{\phantom{1}\ldots\phantom{1}}{\phantom{1}\ldots\phantom{1}}}{2}=\dfrac{\phantom{1}\ldots\phantom{1}}{\phantom{1}\ldots\phantom{1}}$", A[9],A[10], 8mm, joinpen=dashed, darkgray);
distance("$2\div \dfrac{\phantom{1}\ldots\phantom{1}}{\phantom{1}\ldots\phantom{1}}=\dfrac{\phantom{1}\ldots\phantom{1}}{\phantom{1}\ldots\phantom{1}}$", A[12],A[9], rotated=false,12mm, joinpen=dashed,darkgray);
decalage[3]=3;
A[13]=shift((decalage[3],0))*A[9];
A[14]=shift((577/408,0))*A[13];
A[15]=shift((0,816/577))*A[14];
A[16]=shift(A[13]-A[14])*A[15];
path rect3=A[13]--A[14]--A[15]--A[16]--cycle ;
draw(rect3);
coteangledroit(A[13],A[14],A[15],A[16]);
distance(scale(0.9)*"$\dfrac{\dfrac{\phantom{1}\ldots\phantom{1}}{\phantom{1}\ldots\phantom{1}}+\dfrac{\phantom{1}\ldots\phantom{1}}{\phantom{1}\ldots\phantom{1}}}{\phantom{1}\ldots\phantom{1}}=\dfrac{\phantom{1}\ldots\phantom{1}}{\phantom{1}\ldots\phantom{1}}$", A[13],A[14], 8mm, joinpen=dashed, darkgray);
distance("$2\div \dfrac{\phantom{1}\ldots\phantom{1}}{\phantom{1}\ldots\phantom{1}}=\dfrac{\phantom{1}\ldots\phantom{1}}{\phantom{1}\ldots\phantom{1}}$", A[16],A[13], rotated=false,15mm, joinpen=dashed,darkgray);
draw(shift((0,-0.5))*midpoint(A[1]--A[2])..shift((0,-1))*midpoint(A[1]--A[6])..shift((0,-0.5))*midpoint(A[5]--A[6]),1bp+red+dashed,ArcArrow(SimpleHead)); 
draw(shift((0,-0.5))*midpoint(A[5]--A[6])..shift((0,-1))*midpoint(A[5]--A[10])..shift((0,-0.5))*midpoint(A[9]--A[10]),1bp+red+dashed,ArcArrow(SimpleHead));
draw(shift((0,-0.5))*midpoint(A[9]--A[10])..shift((0,-1))*midpoint(A[9]--A[14])..shift((0,-0.5))*midpoint(A[13]--A[14]),1bp+red+dashed,ArcArrow(SimpleHead));  
//draw((A[1]+A[2])/2..((xpart(A[1])+xpart(A[6]))/2),-1)..(A[5]+A[6])/2,1bp+red+dashed,ArcArrow(SimpleHead)); 

label("Moyenne des 2 dimensions du rectangle précédent",shift((0,-1))*midpoint(A[1]--A[6]),S,red);
label("$\mathcal{A}_{\text{rectangle}}=2$",midpoint(A[2]--A[4]),S,red);
label("$\mathcal{A}_{\text{rectangle}}=2$",midpoint(A[6]--A[8]),S,red);
label("$\mathcal{A}_{\text{rectangle}}=2$",midpoint(A[10]--A[12]),S,red);
label("$\mathcal{A}_{\text{rectangle}}=2$",midpoint(A[14]--A[16]),S,red);

